
<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta charset="utf-8" />
    <title>Debug and logging &#8212; pyroute2 0.5.14 documentation</title>
    <link rel="stylesheet" href="_static/classic.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <link rel="stylesheet" type="text/css" href="_static/graphviz.css" />
    <link rel="stylesheet" type="text/css" href="_static/custom.css" />
    
    <script type="text/javascript" id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script type="text/javascript" src="_static/language_data.js"></script>
    
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Authorization plugins" href="ndb_auth.html" />
    <link rel="prev" title="RTNL sources" href="ndb_sources.html" />
<!-- Global site tag (gtag.js) - Google Analytics -->
<script async src="https://www.googletagmanager.com/gtag/js?id=UA-121787797-2"></script>
<script>
  window.dataLayer = window.dataLayer || [];
  function gtag(){dataLayer.push(arguments);}
  gtag('js', new Date());

  gtag('config', 'UA-121787797-2');
</script>
 

  </head><body>

    <div class="related" role="navigation" aria-label="related navigation">
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="ndb_auth.html" title="Authorization plugins"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="ndb_sources.html" title="RTNL sources"
             accesskey="P">previous</a> |</li>
        <li class="nav-item"><a href="http://pyroute2.org">Project home</a> &#187;</li>
        <li class="nav-item nav-item-0"><a href="index.html">pyroute2 0.5.14 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="ndb.html" accesskey="U">NDB module</a> &#187;</li> 
      </ul>
        </div>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="debug-and-logging">
<span id="ndbdebug"></span><h1>Debug and logging<a class="headerlink" href="#debug-and-logging" title="Permalink to this headline">¶</a></h1>
<div class="section" id="logging">
<h2>Logging<a class="headerlink" href="#logging" title="Permalink to this headline">¶</a></h2>
<p>A simple way to set up stderr logging:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="c1"># to start logging on the DB init</span>
<span class="n">ndb</span> <span class="o">=</span> <span class="n">NDB</span><span class="p">(</span><span class="n">log</span><span class="o">=</span><span class="s1">&#39;on&#39;</span><span class="p">)</span>

<span class="c1"># ... or to start it in run time</span>
<span class="n">ndb</span><span class="o">.</span><span class="n">log</span><span class="p">(</span><span class="s1">&#39;on&#39;</span><span class="p">)</span>

<span class="c1"># ... the same as above, another syntax</span>
<span class="n">ndb</span><span class="o">.</span><span class="n">log</span><span class="o">.</span><span class="n">on</span>

<span class="c1"># ... turn logging off</span>
<span class="n">ndb</span><span class="o">.</span><span class="n">log</span><span class="p">(</span><span class="s1">&#39;off&#39;</span><span class="p">)</span>

<span class="c1"># ... or</span>
<span class="n">ndb</span><span class="o">.</span><span class="n">log</span><span class="o">.</span><span class="n">off</span>
</pre></div>
</div>
<p>It is possible also to set up logging to a file or to a syslog server:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="c1">#</span>
<span class="n">ndb</span><span class="o">.</span><span class="n">log</span><span class="p">(</span><span class="s1">&#39;file_name.log&#39;</span><span class="p">)</span>

<span class="c1">#</span>
<span class="n">ndb</span><span class="o">.</span><span class="n">log</span><span class="p">(</span><span class="s1">&#39;syslog://server:port&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="section" id="fetching-db-data">
<h2>Fetching DB data<a class="headerlink" href="#fetching-db-data" title="Permalink to this headline">¶</a></h2>
<p>By default, NDB starts with an in-memory SQLite3 database. In order to
perform post mortem analysis it may be more useful to start the DB with
a file DB or a PostgreSQL as the backend.</p>
<p>See more: <a class="reference internal" href="ndb_schema.html#ndbschema"><span class="std std-ref">Database</span></a></p>
<p>It is possible to dump all the DB data with <cite>schema.export()</cite>:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="k">with</span> <span class="n">NDB</span><span class="p">()</span> <span class="k">as</span> <span class="n">ndb</span><span class="p">:</span>
   <span class="n">ndb</span><span class="o">.</span><span class="n">schema</span><span class="o">.</span><span class="n">export</span><span class="p">(</span><span class="s1">&#39;stderr&#39;</span><span class="p">)</span>  <span class="c1"># dump the DB to stderr</span>
   <span class="o">...</span>
   <span class="n">ndb</span><span class="o">.</span><span class="n">schema</span><span class="o">.</span><span class="n">export</span><span class="p">(</span><span class="s1">&#39;pr2_debug&#39;</span><span class="p">)</span>  <span class="c1"># dump the DB to a file</span>
</pre></div>
</div>
</div>
<div class="section" id="rtnl-events">
<h2>RTNL events<a class="headerlink" href="#rtnl-events" title="Permalink to this headline">¶</a></h2>
<p>All the loaded RTNL events may be stored in the DB. To turn that feature
on, one should start NDB with the <cite>debug</cite> option:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">ndb</span> <span class="o">=</span> <span class="n">NDB</span><span class="p">(</span><span class="n">rtnl_debug</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
</pre></div>
</div>
<p>The events may be exported with the same <cite>schema.export()</cite>.</p>
<p>Unlike ordinary table, limited with the number of network objects in the
system, the events log tables are not limited. Do not enable the events
logging in production, it may exhaust all the memory.</p>
</div>
<div class="section" id="rtnl-objects">
<h2>RTNL objects<a class="headerlink" href="#rtnl-objects" title="Permalink to this headline">¶</a></h2>
<p>NDB creates RTNL objects on demand, it doesn’t keep them all the time.
References to created objects are linked to the <cite>ndb.&lt;view&gt;.cache</cite> set:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">ndb</span><span class="o">.</span><span class="n">interfaces</span><span class="o">.</span><span class="n">cache</span><span class="o">.</span><span class="n">keys</span><span class="p">()</span>
<span class="go">[((&#39;target&#39;, u&#39;localhost&#39;), (&#39;index&#39;, 2)),</span>
<span class="go"> ((&#39;target&#39;, u&#39;localhost&#39;), (&#39;index&#39;, 39615))]</span>

<span class="gp">&gt;&gt;&gt; </span><span class="p">[</span><span class="n">x</span><span class="p">[</span><span class="s1">&#39;ifname&#39;</span><span class="p">]</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">ndb</span><span class="o">.</span><span class="n">interfaces</span><span class="o">.</span><span class="n">cache</span><span class="o">.</span><span class="n">values</span><span class="p">()]</span>
<span class="go">[u&#39;eth0&#39;, u&#39;t2&#39;]</span>
</pre></div>
</div>
</div>
<div class="section" id="object-states">
<h2>Object states<a class="headerlink" href="#object-states" title="Permalink to this headline">¶</a></h2>
<p>RTNL objects may be in several states:</p>
<blockquote>
<div><ul class="simple">
<li><p>invalid: the object does not exist in the system</p></li>
<li><p>system: the object exists both in the system and in NDB</p></li>
<li><p>setns: the existing object should be moved to another network namespace</p></li>
<li><p>remove: the existing object must be deleted from the system</p></li>
</ul>
</div></blockquote>
<p>The state transitions are logged in the state log:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">pyroute2</span> <span class="k">import</span> <span class="n">NDB</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">ndb</span> <span class="o">=</span> <span class="n">NDB</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">c</span> <span class="o">=</span> <span class="n">ndb</span><span class="o">.</span><span class="n">interfaces</span><span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="n">ifname</span><span class="o">=</span><span class="s1">&#39;t0&#39;</span><span class="p">,</span> <span class="n">kind</span><span class="o">=</span><span class="s1">&#39;dummy&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">commit</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">c</span><span class="o">.</span><span class="n">state</span><span class="o">.</span><span class="n">events</span>
<span class="go">[</span>
<span class="go">   (1557752212.6703758, &#39;invalid&#39;),</span>
<span class="go">   (1557752212.6821117, &#39;system&#39;)</span>
<span class="go">]</span>
</pre></div>
</div>
<p>The timestamps allow to correlate the state transitions with the
NDB log and the RTNL events log, in the case it was enabled.</p>
</div>
<div class="section" id="object-snapshots">
<h2>Object snapshots<a class="headerlink" href="#object-snapshots" title="Permalink to this headline">¶</a></h2>
<p>Before running any commit, NDB marks all the related records in the DB
with a random value in the <cite>f_tflags</cite> DB field (<cite>tflags</cite> object field),
and stores all the marked records in the snapshot tables. Shortly, the
<cite>commit()</cite> is a <cite>snapshot() + apply() + revert() if failed</cite>:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">nic</span> <span class="o">=</span> <span class="n">ndb</span><span class="o">.</span><span class="n">interfaces</span><span class="p">[</span><span class="s1">&#39;t0&#39;</span><span class="p">]</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">nic</span><span class="p">[</span><span class="s1">&#39;state&#39;</span><span class="p">]</span>
<span class="go">&#39;down&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">nic</span><span class="p">[</span><span class="s1">&#39;state&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;up&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">snapshot</span> <span class="o">=</span> <span class="n">nic</span><span class="o">.</span><span class="n">snapshot</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">ndb</span><span class="o">.</span><span class="n">schema</span><span class="o">.</span><span class="n">snapshots</span>
<span class="go">{</span>
<span class="go">   &#39;addresses_139736119707256&#39;: &lt;weakref at 0x7f16d8391a98; to &#39;Interface&#39; at 0x7f16d9c708e0&gt;,</span>
<span class="go">   &#39;neighbours_139736119707256&#39;: &lt;weakref at 0x7f16d8391a98; to &#39;Interface&#39; at 0x7f16d9c708e0&gt;,</span>
<span class="go">   &#39;routes_139736119707256&#39;: &lt;weakref at 0x7f16d8391a98; to &#39;Interface&#39; at 0x7f16d9c708e0&gt;,</span>
<span class="go">   &#39;nh_139736119707256&#39;: &lt;weakref at 0x7f16d8391a98; to &#39;Interface&#39; at 0x7f16d9c708e0&gt;,</span>
<span class="go">   &#39;p2p_139736119707256&#39;: &lt;weakref at 0x7f16d8391a98; to &#39;Interface&#39; at 0x7f16d9c708e0&gt;,</span>
<span class="go">   &#39;ifinfo_bridge_139736119707256&#39;: &lt;weakref at 0x7f16d8391a98; to &#39;Interface&#39; at 0x7f16d9c708e0&gt;,</span>
<span class="go">   &#39;ifinfo_bond_139736119707256&#39;: &lt;weakref at 0x7f16d8391a98; to &#39;Interface&#39; at 0x7f16d9c708e0&gt;,</span>
<span class="go">   &#39;ifinfo_vlan_139736119707256&#39;: &lt;weakref at 0x7f16d8391a98; to &#39;Interface&#39; at 0x7f16d9c708e0&gt;,</span>
<span class="go">   &#39;ifinfo_vxlan_139736119707256&#39;: &lt;weakref at 0x7f16d8391a98; to &#39;Interface&#39; at 0x7f16d9c708e0&gt;,</span>
<span class="go">   &#39;ifinfo_gre_139736119707256&#39;: &lt;weakref at 0x7f16d8391a98; to &#39;Interface&#39; at 0x7f16d9c708e0&gt;,</span>
<span class="go">   &#39;ifinfo_vrf_139736119707256&#39;: &lt;weakref at 0x7f16d8391a98; to &#39;Interface&#39; at 0x7f16d9c708e0&gt;,</span>
<span class="go">   &#39;ifinfo_vti_139736119707256&#39;: &lt;weakref at 0x7f16d8391a98; to &#39;Interface&#39; at 0x7f16d9c708e0&gt;,</span>
<span class="go">   &#39;ifinfo_vti6_139736119707256&#39;: &lt;weakref at 0x7f16d8391a98; to &#39;Interface&#39; at 0x7f16d9c708e0&gt;,</span>
<span class="go">   &#39;interfaces_139736119707256&#39;: &lt;weakref at 0x7f16d8391a98; to &#39;Interface&#39; at 0x7f16d9c708e0&gt;</span>
<span class="go">}</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">nic</span><span class="o">.</span><span class="n">apply</span><span class="p">()</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">nic</span><span class="p">[</span><span class="s1">&#39;state&#39;</span><span class="p">]</span>
<span class="go">&#39;up&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">snapshot</span><span class="o">.</span><span class="n">apply</span><span class="p">(</span><span class="n">rollback</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">nic</span><span class="p">[</span><span class="s1">&#39;state&#39;</span><span class="p">]</span>
<span class="go">&#39;down&#39;</span>
</pre></div>
</div>
<p>Or same:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">nic</span> <span class="o">=</span> <span class="n">ndb</span><span class="o">.</span><span class="n">interfaces</span><span class="p">[</span><span class="s1">&#39;t0&#39;</span><span class="p">]</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">nic</span><span class="p">[</span><span class="s1">&#39;state&#39;</span><span class="p">]</span>
<span class="go">&#39;down&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">nic</span><span class="p">[</span><span class="s1">&#39;state&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;up&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">nic</span><span class="o">.</span><span class="n">commit</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">nic</span><span class="p">[</span><span class="s1">&#39;state&#39;</span><span class="p">]</span>
<span class="go">&#39;up&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">nic</span><span class="o">.</span><span class="n">rollback</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">nic</span><span class="p">[</span><span class="s1">&#39;state&#39;</span><span class="p">]</span>
<span class="go">&#39;down&#39;</span>
</pre></div>
</div>
<p>These snapshot tables are the objects’ state before the changes were applied.</p>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">Debug and logging</a><ul>
<li><a class="reference internal" href="#logging">Logging</a></li>
<li><a class="reference internal" href="#fetching-db-data">Fetching DB data</a></li>
<li><a class="reference internal" href="#rtnl-events">RTNL events</a></li>
<li><a class="reference internal" href="#rtnl-objects">RTNL objects</a></li>
<li><a class="reference internal" href="#object-states">Object states</a></li>
<li><a class="reference internal" href="#object-snapshots">Object snapshots</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="ndb_sources.html"
                        title="previous chapter">RTNL sources</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="ndb_auth.html"
                        title="next chapter">Authorization plugins</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/ndb_debug.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="ndb_auth.html" title="Authorization plugins"
             >next</a> |</li>
        <li class="right" >
          <a href="ndb_sources.html" title="RTNL sources"
             >previous</a> |</li>
        <li class="nav-item"><a href="http://pyroute2.org">Project home</a> &#187;</li>
        <li class="nav-item nav-item-0"><a href="index.html">pyroute2 0.5.14 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="ndb.html" >NDB module</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2013, Peter V. Saveliev.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 2.1.2.
    </div>
  </body>
</html>